extends KinematicBody

export(float,0.1,1.0) var sensitivity = 0.001
var mouse_motion = Vector2()
var dafaule_move_speed = 1.0
var speedup_move_speed = 2.5

var rot_x = 0.0
var rot_y = 0.0
func _ready():
	rot_x = transform.basis.get_euler().y
	rot_y = transform.basis.get_euler().x
	Input.set_mouse_mode(Input.MOUSE_MODE_CAPTURED)

func _physics_process(_delta):
	var velocity:Vector3 = _axis() * 1
	move_and_slide(velocity)

# https://docs.godotengine.org/en/stable/tutorials/3d/using_transforms.html#setting-information
func _input(event):
	if Input.get_mouse_mode() == Input.MOUSE_MODE_CAPTURED && event is InputEventMouseMotion:
		mouse_motion = event.relative
		rot_x += -(event.relative.x * 0.01)
		rot_y += -(event.relative.y * 0.01)
		transform.basis = Basis() # reset rotation
		rotate_object_local(Vector3(0, 1, 0), rot_x) # first rotate in Y
		rotate_object_local(Vector3(1, 0, 0), rot_y) # then rotate in X
	if Input.is_key_pressed(KEY_ESCAPE):
		Input.set_mouse_mode(Input.MOUSE_MODE_VISIBLE)
	elif Input.get_mouse_button_mask() > 0:
		Input.set_mouse_mode(Input.MOUSE_MODE_CAPTURED)

func _axis():
	var direction = Vector3()
	if Input.is_key_pressed(KEY_W):
		direction -= get_global_transform().basis.z.normalized()
		
	if Input.is_key_pressed(KEY_S):
		direction += get_global_transform().basis.z.normalized()
		
	if Input.is_key_pressed(KEY_A):
		direction -= get_global_transform().basis.x.normalized()
		
	if Input.is_key_pressed(KEY_D):
		direction += get_global_transform().basis.x.normalized()
	
	if Input.is_key_pressed(KEY_Q):
		direction -= get_global_transform().basis.y.normalized()
	
	if Input.is_key_pressed(KEY_E):
		direction += get_global_transform().basis.y.normalized()
	
	direction = direction.normalized()
	
	if Input.is_key_pressed(KEY_SHIFT):
		direction *= speedup_move_speed
		
	return direction
